#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Uma funcao que ordena um array de strings.
 * Entrada:  array a ser ordenado -- *strings[]
 *           flag: 0 ordem crescente, 1 ordem decrescente
 *
 * Nota:  ultimo elemento do array de strings eh um ponteiro nulo (NULL)
 */
void sort_strings(char *strings[], int reverso)
{
  int i, j;       /* se 1 depois da passagem o array esta' ordenado */
  char  *temp;

  for(i=0; strings[i+1] != NULL; ++i)
    for(j=i+1; strings[j] != NULL; ++j)
      if (( !reverso && strcmp (strings[i], strings[j]) > 0) || (reverso && strcmp (strings[i], strings[j]) < 0)){
	temp = strings[i];
	strings[i] = strings[j];
	strings[j] = temp;
      }
}



/* Uma funcao que ordena um array de inteiros usando o algoritmo de
 * Bubble sort.
 * Entrada:  array a ser ordenado -- lista[]
 *           tamanho do array -- tam
 */
void sort_int(int lista[], int tam)
{
  int ordenado,       /* se 1 depois da passagem o array esta' ordenado */
      elem_final = 1, /* em uma passagem, elementos do ultimo ate' elem_final
                         sao comparados com o elemento anterior */
      i,j,
      temp;
  
  /* enquanto o array nao estiver ordenado, fazer uma passagem sobre ele */
  do {
    ordenado = 1;  /* assume que array esta' ordenado */
    
    /* Examina o array do ultimo elemento ate elem_final.  Compara
       cada elemento com o anteior e troca seus valores se estiver
       fora de ordem.  */
    
    for (i = tam - 1; i >= elem_final; i--) {
      
      if (lista[i] < lista[i - 1]) {  /* troca os elementos de i e i-1 */
	temp = lista[i];
	lista[i] = lista[i - 1];
	lista[i - 1] = temp;
	ordenado = 0;         /* marca como nao ordenado */
      }
    }
    
    elem_final++;
    
  } while (!ordenado);
}
